#include "mpi.h"

/*
    MPI-specific routines
 */
MPI_Status __STATUS;
int __NUMNODES, __MYPROCID, __MPILEN, __FLAG;

int PICall( routine, argc, argv )
int  argc;
char **argv;
int  (*routine)();
{
int rc;

MPI_Init(&argc,&argv);
MPI_Comm_size(MPI_COMM_WORLD,&__NUMNODES);
MPI_Comm_rank(MPI_COMM_WORLD,&__MYPROCID);
/* printf("[%d] PICall starting up\n",__MYPROCID); */
rc = (*routine)( argc, argv );
MPI_Finalize();
/* printf("[%d] PICall exiting, routine return value = %d\n",__MYPROCID,rc); */

return rc;
}

#define PI_HAS_NODENAME

void PINodeName( name, maxlen )
char *name;
int  maxlen;
{
int rlen;
MPI_Get_processor_name( name, &rlen );
}
